package org.gcube.informationsystem.utils.documentation.model.relations;

import java.util.Set;

import org.gcube.informationsystem.base.reference.AccessType;
import org.gcube.informationsystem.types.reference.Type;
import org.gcube.informationsystem.types.reference.properties.LinkedEntity;
import org.gcube.informationsystem.utils.documentation.knowledge.FacetKnowledge;
import org.gcube.informationsystem.utils.documentation.rst.table.Table;

/**
 * @author Luca Frosini (ISTI - CNR)
 */
public class ConsistsOfDocumentationGenerator extends RelationDocumentationGenerator {

	public ConsistsOfDocumentationGenerator(Type type) {
		super(type, AccessType.CONSISTS_OF);
	}

	@Override
	protected Table getTable() {
		Table table = super.getTable();
		
		table.appendRow(getKnownUsageBoldRow());
		FacetKnowledge fk = FacetKnowledge.getInstace();
		Set<LinkedEntity> facets = fk.getUsage(type.getName());
		addLinkedEntities(table, facets);
		
		return table;
	}

	
}
