package org.gcube.informationsystem.utils.documentation.model.relations;

import java.util.Set;

import org.gcube.informationsystem.base.reference.AccessType;
import org.gcube.informationsystem.types.reference.Type;
import org.gcube.informationsystem.types.reference.properties.LinkedEntity;
import org.gcube.informationsystem.utils.documentation.knowledge.ResourceKnowledge;
import org.gcube.informationsystem.utils.documentation.rst.table.Table;

/**
 * @author Luca Frosini (ISTI - CNR)
 */
public class IsRelatedToDocumentationGenerator extends RelationDocumentationGenerator {

	public IsRelatedToDocumentationGenerator(Type type) {
		super(type, AccessType.IS_RELATED_TO);
	}

	@Override
	protected Table getTable() {
		Table table = super.getTable();
		
		table.appendRow(getKnownUsageBoldRow());
		ResourceKnowledge rk = ResourceKnowledge.getInstace();
		Set<LinkedEntity> resources = rk.getUsage(type.getName());
		addLinkedEntities(table, resources);
		
		return table;
	}

	
}
